ConRO.Shaman = {};
ConRO.Shaman.CheckTalents = function()
end
local ConRO_Shaman, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Shaman.CheckTalents;
	if mode == 1 then
		self.Description = 'Shaman Module [Elemental - Caster]';
		self.NextSpell = ConRO.Shaman.Elemental;
		self.ToggleDamage();
	end;
	if mode == 2 then
		self.Description = 'Shaman Module [Enhancement - Melee]';
		self.NextSpell = ConRO.Shaman.Enhancement;
		self.ToggleDamage();
	end;
	if mode == 3 then
		self.Description = 'Shaman Module [Restoration - Healer]';
		self.NextSpell = ConRO.Shaman.Restoration;
		self.ToggleHealer();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Shaman.CheckTalents;
	if mode == 1 then
		self.NextDef = ConRO.Shaman.ElementalDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Shaman.EnhancementDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Shaman.RestorationDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Shaman.Elemental(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local mael 												= UnitPower('player', Enum.PowerType.Maelstorm);
	local maelMax 											= UnitPowerMax('player', Enum.PowerType.Maelstorm);

--Abilities	
	local purge 											= ConRO:AbilityReady(ids.Ele_Ability.Purge, timeShift);
	local lbolt												= ConRO:AbilityReady(ids.Ele_Ability.LightningBolt, timeShift);
	local lShieldRDY										= ConRO:AbilityReady(ids.Ele_Ability.LightningShield, timeShift);
		local lShieldBUFF										= ConRO:Aura(ids.Ele_Buff.LightningShield, timeShift);	
	local clight											= ConRO:AbilityReady(ids.Ele_Ability.ChainLightning, timeShift);
	local wshear 											= ConRO:AbilityReady(ids.Ele_Ability.WindShear, timeShift);
	local felem, feCD, feMCD								= ConRO:AbilityReady(ids.Ele_Ability.FireElemental, timeShift);
	local eelem, eeCD, eeMCD								= ConRO:AbilityReady(ids.Ele_Ability.EarthElemental, timeShift);
	local lburst											= ConRO:AbilityReady(ids.Ele_Ability.LavaBurst, timeShift);
		local lavaCharges										= ConRO:SpellCharges(ids.Ele_Ability.LavaBurst);
		local lsurgeBuff 										= ConRO:Aura(ids.Ele_Buff.LavaSurge, timeShift);
		local moteBuff 											= ConRO:Aura(ids.Ele_Buff.MasteroftheElements, timeShift);
	local equake											= ConRO:AbilityReady(ids.Ele_Ability.Earthquake, timeShift);
	local eshock 											= ConRO:AbilityReady(ids.Ele_Ability.EarthShock, timeShift);
		local sopBuff											= ConRO:Aura(ids.Ele_Buff.SurgeofPower, timeShift);
	local fshock											= ConRO:AbilityReady(ids.Ele_Ability.FlameShock, timeShift);
		local fsDebuff, _, _FlameShock_DUR						= ConRO:TargetAura(ids.Ele_Debuff.FlameShock, timeShift);
	local frshock											= ConRO:AbilityReady(ids.Ele_Ability.FrostShock, timeShift);
	
	local ifury 											= ConRO:AbilityReady(ids.Ele_Talent.Icefury, timeShift);
		local ifBuff 											= ConRO:Aura(ids.Ele_Buff.Icefury, timeShift);	
	local ascen, ascenCD 									= ConRO:AbilityReady(ids.Ele_Talent.Ascendance, timeShift);
		local ascenBuff 										= ConRO:Aura(ids.Ele_Buff.Ascendance, timeShift);
		local lbeam 											= ConRO:AbilityReady(ids.Ele_Talent.LavaBeam, timeShift);
	local elemblast 										= ConRO:AbilityReady(ids.Ele_Talent.ElementalBlast, timeShift);
	local lmtotem 											= ConRO:AbilityReady(ids.Ele_Talent.LiquidMagmaTotem, timeShift);
	local skeeper 											= ConRO:AbilityReady(ids.Ele_Talent.Stormkeeper, timeShift);
		local skBuff 											= ConRO:Aura(ids.Ele_Buff.Stormkeeper, timeShift);
	local selem, seCD, seMCD								= ConRO:AbilityReady(ids.Ele_Talent.StormElemental, timeShift);
		local wgBuff, wgBCount									= ConRO:Form(ids.Ele_Form.WindGust);
		local callLightningRDY									= ConRO:AbilityReady(ids.Ele_PetAbility.CallLightning, timeShift, 'pet');
		local eotStormRDY										= ConRO:AbilityReady(ids.Ele_PetAbility.EyeoftheStorm, timeShift, 'pet');
	local eshield											= ConRO:AbilityReady(ids.Ele_Talent.EarthShield, timeShift);
	local echoShockRDY										= ConRO:AbilityReady(ids.Ele_Talent.EchoingShock, timeShift);
		local _EchoingShock_BUFF								= ConRO:Aura(ids.Ele_Buff.EchoingShock, timeShift);
	local sDischargeRDY										= ConRO:AbilityReady(ids.Ele_Talent.StaticDischarge, timeShift);

	local _ChainHarvest_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.ChainHarvest, timeShift);
	local _FaeTransfusion_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.FaeTransfusion, timeShift);	
	local _PrimordialWave_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.PrimordialWave, timeShift);
	local _VesperTotem_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.VesperTotem, timeShift);
	
--Conditions
	local incombat 											= UnitAffectingCombat('player');
	local moving 											= ConRO:PlayerSpeed();
	local elemOut											= IsPetActive();
	local currentPetSpell									= select(9, UnitCastingInfo('pet'));
	
	local elemName = UnitName("pet");
	local selemOut = false;
		if elemOut and (elemName == "Greater Storm Elemental" or elemName == "Primal Storm Elemental") then
			selemOut = true;
		end
	
	if currentSpell == ids.Ele_Ability.LavaBurst then
		mael = mael + 10;
		if lavaCharges > 0 then
			lavaCharges = lavaCharges - 1;
		end
	elseif currentSpell == ids.Ele_Ability.LightningBolt then
		mael = mael + 8;
	elseif currentSpell == ids.Ele_Talent.Icefury then
		mael = mael + 15;
	end

	if tChosen[ids.Ele_Talent.EchooftheElements] and lburst then
		lavaCharges = 1;
	end

--Indicators	
	ConRO:AbilityInterrupt(ids.Ele_Ability.WindShear, wshear and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Ele_Ability.Purge, purge and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Ele_Ability.FireElemental, felem and ConRO_SingleButton:IsVisible() and (not tChosen[ids.Ele_Talent.PrimalElementalist] or (tChosen[ids.Ele_Talent.PrimalElementalist] and not elemOut)) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ele_Talent.StormElemental, selem and (not tChosen[ids.Ele_Talent.PrimalElementalist] or (tChosen[ids.Ele_Talent.PrimalElementalist] and not elemOut)) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ele_Ability.EarthElemental, eelem and not (selem or felem) and (not tChosen[ids.Ele_Talent.PrimalElementalist] or (tChosen[ids.Ele_Talent.PrimalElementalist] and not elemOut)));
	ConRO:AbilityBurst(ids.Ele_Talent.Ascendance, ascen and ConRO_SingleButton:IsVisible() and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.FaeTransfusionEND, _FaeTransfusionEND_RDY and _FaeTransfusion_BUFF and _FaeTransfusion_DUR > 2);
	ConRO:AbilityBurst(ids.Covenant_Ability.ChainHarvest, _ChainHarvest_RDY and _MaelstromWeaponCOUNT >= 5 and ConRO_BurstButton:IsVisible());
	
	ConRO:AbilityRaidBuffs(ids.Ele_Talent.EarthShield, eshield and not ConRO:OneBuff(ids.Ele_Buff.EarthShield));
	ConRO:AbilityRaidBuffs(ids.Ele_Ability.LightningShield, lShieldRDY and not lShieldBUFF);
	
--Rotations	
	if not incombat then
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end
		
		if skeeper and currentSpell ~= ids.Ele_Talent.Stormkeeper then
			return ids.Ele_Talent.Stormkeeper;
		end	
		
		if ConRO_FullButton:IsVisible() and (not tChosen[ids.Ele_Talent.PrimalElementalist] or (tChosen[ids.Ele_Talent.PrimalElementalist] and not elemOut)) then
			if tChosen[ids.Ele_Talent.StormElemental] then
				if selem then
					return ids.Ele_Talent.StormElemental;
				end
			else
				if felem then
					return ids.Ele_Ability.FireElemental;
				end
			end
		end

		if _PrimordialWave_RDY and not fsDebuff and (currentSpell == ids.Ele_Talent.ElementalBlast or currentSpell == ids.Ele_Ability.LavaBurst or currentSpell == ids.Ele_Ability.LightningBolt) then
			return ids.Covenant_Ability.PrimordialWave;
		end
		
		if fshock and not fsDebuff and (currentSpell == ids.Ele_Talent.ElementalBlast or currentSpell == ids.Ele_Ability.LavaBurst or currentSpell == ids.Ele_Ability.LightningBolt) then
			return ids.Ele_Ability.FlameShock;
		end	

		if elemblast then
			return ids.Ele_Talent.ElementalBlast;
		end
		
		if lburst then
			return ids.Ele_Ability.LavaBurst;
		end
		
		if lbolt then
			return ids.Ele_Ability.LightningBolt;
		end
	
	elseif ascenBuff then
		if eshock and mael > 90 then
			return ids.Ele_Ability.EarthShock;
		end
		
		if elemblast and currentSpell ~= ids.Ele_Talent.ElementalBlast then
			return ids.Ele_Talent.ElementalBlast;
		end
		
		if lburst then
			return ids.Ele_Ability.LavaBurst;
		end
			
	elseif moving then
		if fshock and not fsDebuff then
			return ids.Ele_Ability.FlameShock;
		end	
	
		if lburst and lsurgeBuff then
			return ids.Ele_Ability.LavaBurst;
		end		
	
		if skBuff then
			if ConRO_AoEButton:IsVisible() then
				if clight then
					return ids.Ele_Ability.ChainLightning;
				end
			else
				if lbolt then
					return ids.Ele_Ability.LightningBolt;
				end	
			end
		end
		
		if frshock then
			return ids.Ele_Ability.FrostShock;
		end
	
	elseif ConRO_AoEButton:IsVisible() then
		if callLightningRDY and selemOut and seCD >= 135 and currentPetSpell ~= ids.Ele_PetAbility.CallLightning then
			return ids.Ele_PetAbility.CallLightning;
		end
		
		if eotStormRDY and selemOut and tChosen[ids.Ele_Talent.PrimalElementalist] and currentPetSpell ~= ids.Ele_PetAbility.EyeoftheStorm and currentPetSpell ~= ids.Ele_PetAbility.CallLightning then
			return ids.Ele_PetAbility.EyeoftheStorm;
		end	

		if _PrimordialWave_RDY and not fsDebuff then
			return ids.Covenant_Ability.PrimordialWave;
		end

		if fshock and not fsDebuff then
			return ids.Ele_Ability.FlameShock;
		end	

		if skeeper and currentSpell ~= ids.Ele_Talent.Stormkeeper then
			return ids.Ele_Talent.Stormkeeper;
		end	

		if _ChainHarvest_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ChainHarvest;
		end	

		if echoShockRDY and mael >= 60 then
			return ids.Ele_Talent.EchoingShock;
		end
		
		if lmtotem then
			return ids.Ele_Talent.LiquidMagmaTotem;
		end
		
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end
		
		if lburst and lsurgeBuff and mael >= 60 and tChosen[ids.Ele_Talent.MasteroftheElements] then
			return ids.Ele_Ability.LavaBurst;
		end		

		if equake and mael >= 60 then
			return ids.Ele_Ability.Earthquake;
		end	

		if elemblast and currentSpell ~= ids.Ele_Talent.ElementalBlast then
			return ids.Ele_Talent.ElementalBlast;
		end
		
		if selem and tChosen[ids.Ele_Talent.StormElemental] and tChosen[ids.Ele_Talent.PrimalElementalist] and not elemOut and ConRO_FullButton:IsVisible() then
			return ids.Ele_Talent.StormElemental;
		end

		if _FaeTransfusion_RDY then
			return ids.Covenant_Ability.FaeTransfusion;
		end
		
		if clight then
			return ids.Ele_Ability.ChainLightning;
		end
		
	else
		if _PrimordialWave_RDY and not fsDebuff and wgBCount <= 13 then
			return ids.Covenant_Ability.PrimordialWave;
		end
		
		if fshock and not fsDebuff and wgBCount <= 13 then
			return ids.Ele_Ability.FlameShock;
		end
	
		if ConRO_FullButton:IsVisible() and (not tChosen[ids.Ele_Talent.PrimalElementalist] or (tChosen[ids.Ele_Talent.PrimalElementalist] and not elemOut)) then
			if tChosen[ids.Ele_Talent.StormElemental] then
				if selem then
					return ids.Ele_Talent.StormElemental;
				end
			else
				if felem then
					return ids.Ele_Ability.FireElemental;
				end
			end
		end

		if _FaeTransfusion_RDY and tChosen[ids.Ele_Talent.MasteroftheElements] then
			return ids.Covenant_Ability.FaeTransfusion;
		end
		
		if eshock and mael >= 90 then
			return ids.Ele_Ability.EarthShock;
		end

		if elemblast and not moteBuff and not selemOut and currentSpell ~= ids.Ele_Talent.ElementalBlast then
			return ids.Ele_Talent.ElementalBlast;
		end	
		
		if _FaeTransfusion_RDY then
			return ids.Covenant_Ability.FaeTransfusion;
		end
		
		if skeeper and currentSpell ~= ids.Ele_Talent.Stormkeeper then
			return ids.Ele_Talent.Stormkeeper;
		end		

		if _PrimordialWave_RDY and ConRO.lastSpellId ~= ids.Covenant_Ability.PrimordialWave then
			return ids.Covenant_Ability.PrimordialWave;
		end

		if echoShockRDY and (mael >= 60 or lburst) then
			return ids.Ele_Talent.EchoingShock;
		end
		
		if lburst and lavaCharges >= 1 and _EchoingShock_BUFF then
			return ids.Ele_Ability.LavaBurst;
		end
		
		if lbolt and ((sopBuff and skBuff) or (not tChosen[ids.Ele_Talent.SurgeofPower] and moteBuff)) then
			return ids.Ele_Ability.LightningBolt;
		end
		
		if lmtotem then
			return ids.Ele_Talent.LiquidMagmaTotem;
		end
		
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end		

		if eshock and mael >= 60 and moteBuff then
			return ids.Ele_Ability.EarthShock;
		end

		if lbolt and selemOut or wgBuff then
			return ids.Ele_Ability.LightningBolt;
		end
			
		if ascen and ConRO_SingleButton:IsVisible() and ConRO_FullButton:IsVisible() then
			return ids.Ele_Talent.Ascendance;
		end
		
		if frshock and ifBuff and moteBuff then
			return ids.Ele_Ability.FrostShock;
		end
		
		if lbolt and sopBuff then
			return ids.Ele_Ability.LightningBolt;
		end	
		
		if lburst and lavaCharges >= 1 then
			return ids.Ele_Ability.LavaBurst;
		end
		
		if fshock and _FlameShock_DUR <= 6 then
			return ids.Ele_Ability.FlameShock;
		end

		if eshock and mael >= 60 then
			return ids.Ele_Ability.EarthShock;
		end

		if frshock and ifBuff then
			return ids.Ele_Ability.FrostShock;
		end

		if ifury then
			return ids.Ele_Talent.Icefury;
		end
		
		if _ChainHarvest_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ChainHarvest;
		end		

		if sDischargeRDY and lShieldBUFF then
			return ids.Ele_Talent.StaticDischarge;
		end

		if frshock and moving then
			return ids.Ele_Ability.FrostShock;
		end	
		
		if lbolt then
			return ids.Ele_Ability.LightningBolt;
		end
	end
end

function ConRO.Shaman.ElementalDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities
	local astral											 = ConRO:AbilityReady(ids.Ele_Ability.AstralShift, timeShift);

	local _FaeTransfusionEND_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.FaeTransfusionEND, timeShift);	
		local _FaeTransfusion_BUFF								= ConRO:Aura(ids.Covenant_Buff.FaeTransfusion, timeShift);
	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Rotations	
	if _FaeTransfusionEND_RDY and _FaeTransfusion_BUFF then
		return ids.Covenant_Ability.FaeTransfusionEND;
	end
	
	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end	
	
	if astral then
		return ids.Ele_Ability.AstralShift;
	end
return nil;
end

function ConRO.Shaman.Enhancement(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local mana 												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manaPercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	
--Abilities
	local purge 											= ConRO:AbilityReady(ids.Enh_Ability.Purge, timeShift);
	local ss												= ConRO:AbilityReady(ids.Enh_Ability.Stormstrike, timeShift);
		local sbBuff 											= ConRO:Aura(ids.Enh_Buff.Stormbringer, timeShift);
	local fs, fsCD 											= ConRO:AbilityReady(ids.Enh_Ability.FeralSpirit, timeShift);
	local _FlameShockRDY									= ConRO:AbilityReady(ids.Enh_Ability.FlameShock, timeShift);
		local _FlameShockDEBUFF, _, _FlameShockDUR				= ConRO:TargetAura(ids.Ele_Debuff.FlameShock, timeShift);
	local _ChainLightningRDY								= ConRO:AbilityReady(ids.Enh_Ability.ChainLightning, timeShift);
	local cl 												= ConRO:AbilityReady(ids.Enh_Ability.CrashLightning, timeShift);
		local clBuff 											= ConRO:Aura(ids.Enh_Buff.CrashLightning, timeShift);
	local wshear 											= ConRO:AbilityReady(ids.Enh_Ability.WindShear, timeShift);
	local _LightningBoltRDY									= ConRO:AbilityReady(ids.Enh_Ability.LightningBolt, timeShift);
		local _, _MaelstromWeaponCOUNT							= ConRO:Aura(ids.Enh_Buff.MaelstromWeapon, timeShift);
	local _LavaLashRDY										= ConRO:AbilityReady(ids.Enh_Ability.LavaLash, timeShift);
		local _HotHandBUFF										= ConRO:Aura(ids.Enh_Buff.HotHand, timeShift);
		local _LashingFlamesDEBUFF								= ConRO:TargetAura(ids.Enh_Debuff.LashingFlames, timeShift);		
	local lshield											= ConRO:AbilityReady(ids.Enh_Ability.LightningShield, timeShift);
		local lsBuff											= ConRO:Aura(ids.Enh_Buff.LightningShield, timeShift);
	local _WindfuryTotemRDY									= ConRO:AbilityReady(ids.Enh_Ability.WindfuryTotem, timeShift);
		local _WindfuryTotemBUFF								= ConRO:Form(ids.Enh_Form.WindfuryTotem);
	local _FrostShockRDY									= ConRO:AbilityReady(ids.Enh_Ability.FrostShock, timeShift);
		local _HailstormBUFF									= ConRO:Aura(ids.Enh_Buff.Hailstorm, timeShift);
	local _WindfuryWeaponRDY								= ConRO:AbilityReady(ids.Enh_Ability.WindfuryWeapon, timeShift);
		local _WindfuryWeaponBuff								= ConRO:UnitAura(ids.Enh_Buff.WindfuryWeapon, timeShift, _, _, "Weapon");
	local _FlametongueWeaponRDY								= ConRO:AbilityReady(ids.Enh_Ability.FlametongueWeapon, timeShift);
		local _FlametongueWeaponBuff							= ConRO:UnitAura(ids.Enh_Buff.FlametongueWeapon, timeShift, _, _, "Weapon");
		
	local ascen 											= ConRO:AbilityReady(ids.Enh_Talent.Ascendance, timeShift);
		local asBuff											= ConRO:Aura(ids.Enh_Buff.Ascendance, timeShift);
		local wstrike						 					= ConRO:AbilityReady(ids.Enh_Talent.Windstrike, timeShift);
	local espike, _, _, _, espikeRANGE						= ConRO:AbilityReady(ids.Enh_Talent.EarthenSpike, timeShift);
	local sunder 											= ConRO:AbilityReady(ids.Enh_Talent.Sundering, timeShift);	
	local eshield											= ConRO:AbilityReady(ids.Enh_Talent.EarthShield, timeShift);
	local _ElementalBlastRDY								= ConRO:AbilityReady(ids.Enh_Talent.ElementalBlast, timeShift);
	local _IceStrikeRDY										= ConRO:AbilityReady(ids.Enh_Talent.IceStrike, timeShift);
	local _FireNovaRDY										= ConRO:AbilityReady(ids.Enh_Talent.FireNova, timeShift);
	local fLungeRDY, _, _, _, fLungeRANGE					= ConRO:AbilityReady(ids.Enh_Talent.FeralLunge, timeShift);
	local _StormkeeperRDY									= ConRO:AbilityReady(ids.Enh_Talent.Stormkeeper, timeShift);
		local _StormkeeperBUFF									= ConRO:Aura(ids.Enh_Buff.Stormkeeper, timeShift);

	local _ChainHarvest_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.ChainHarvest, timeShift);
	local _FaeTransfusion_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.FaeTransfusion, timeShift);
	local _PrimordialWave_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.PrimordialWave, timeShift);
	local _VesperTotem_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.VesperTotem, timeShift);

--Conditions	
	local incombat 											= UnitAffectingCombat('player');
	local inMelee 											= ConRO:IsSpellInRange(GetSpellInfo(ids.Enh_Ability.LavaLash), 'target')
	local tarInMelee										= ConRO:Targets(ids.Enh_Ability.LavaLash);
	local tar10RANGE										= CheckInteractDistance("target", 3);

	local imbueWeapons = false;
		if not _WindfuryWeaponBuff then
			imbueWeapons = true;
		elseif not _FlametongueWeaponBuff then
			imbueWeapons = true;
		end
		
--Indicators	
	ConRO:AbilityInterrupt(ids.Enh_Ability.WindShear, wshear and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Enh_Ability.Purge, purge and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Enh_Talent.Ascendance, ascen and not ss and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Enh_Ability.FeralSpirit, fs and ftBuff and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.FaeTransfusionEND, _FaeTransfusionEND_RDY and _FaeTransfusion_BUFF and _FaeTransfusion_DUR > 2);
	ConRO:AbilityBurst(ids.Covenant_Ability.ChainHarvest, _ChainHarvest_RDY and _MaelstromWeaponCOUNT >= 5 and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Enh_Ability.WindfuryTotem, _WindfuryTotemRDY and not _WindfuryTotemBUFF and ConRO_BurstButton:IsVisible());

	ConRO:AbilityRaidBuffs(ids.Enh_Talent.EarthShield, eshield and not ConRO:OneBuff(ids.Enh_Buff.EarthShield));
	ConRO:AbilityRaidBuffs(ids.Enh_Ability.LightningShield, lshield and not lsBuff);
	ConRO:AbilityRaidBuffs(ids.Enh_Ability.WindfuryWeapon, _WindfuryWeaponRDY and not _WindfuryWeaponBuff);
	ConRO:AbilityRaidBuffs(ids.Enh_Ability.FlametongueWeapon, _FlametongueWeaponRDY and not _FlametongueWeaponBuff);
	
	ConRO:AbilityMovement(ids.Enh_Talent.FeralLunge, fLungeRDY and fLungeRANGE);

--Warnings	
	if (_WindfuryWeaponRDY or _FlametongueWeaponRDY) and imbueWeapons and incombat then
		UIErrorsFrame:AddMessage("Put weapon imbues on your weapon!!!", 1.0, 0.0, 0.0, 53, 5);
	end

--Rotations
	if not incombat then
		if _WindfuryTotemRDY and not _WindfuryTotemBUFF and ConRO_FullButton:IsVisible() then
			return ids.Enh_Ability.WindfuryTotem;
		end
		
		if _StormkeeperRDY then
			return ids.Enh_Talent.Stormkeeper;
		end			
		
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end

		if _PrimordialWave_RDY and not _FlameShockDEBUFF then
			return ids.Covenant_Ability.PrimordialWave;
		end
		
		if _FlameShockRDY and not _FlameShockDEBUFF then
			return ids.Enh_Ability.FlameShock;
		end		

		if espike and espikeRANGE then
			return ids.Enh_Talent.EarthenSpike;
		end

		if ss and inMelee and not asBuff then
			return ids.Enh_Ability.Stormstrike;
		end
		
		if fs and ConRO_FullButton:IsVisible() then
			return ids.Enh_Ability.FeralSpirit;
		end			

		if ss and asBuff then
			return ids.Enh_Talent.Windstrike;
		end

		if ascen and not ss and ConRO_FullButton:IsVisible() then
			return ids.Enh_Talent.Ascendance;
		end
		
	elseif tChosen[ids.Enh_Talent.Hailstorm] and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		if _WindfuryTotemRDY and not _WindfuryTotemBUFF and ConRO_FullButton:IsVisible() then
			return ids.Enh_Ability.WindfuryTotem;
		end
		
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end

		if _FrostShockRDY and _HailstormBUFF then
			return ids.Enh_Ability.FrostShock;
		end
		
		if _FaeTransfusion_RDY then
			return ids.Covenant_Ability.FaeTransfusion;
		end

		if sunder and tar10RANGE then
			return ids.Enh_Talent.Sundering;
		end
	
		if fs and ConRO_FullButton:IsVisible() then
			return ids.Enh_Ability.FeralSpirit;
		end	
		
		if _ChainHarvest_RDY and _MaelstromWeaponCOUNT >= 5 and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ChainHarvest;
		end

		if _ChainLightningRDY and _MaelstromWeaponCOUNT >= 5 then
			return ids.Enh_Ability.ChainLightning;
		end

		if cl and inMelee then
			return ids.Enh_Ability.CrashLightning;
		end

		if ss and asBuff then
			return ids.Enh_Talent.Windstrike;
		end
		
		if ss and inMelee and not asBuff then
			return ids.Enh_Ability.Stormstrike;
		end

		if _LavaLashRDY and inMelee then
			return ids.Enh_Ability.LavaLash;
		end
		
	else
		if _WindfuryTotemRDY and not _WindfuryTotemBUFF and ConRO_FullButton:IsVisible() then
			return ids.Enh_Ability.WindfuryTotem;
		end

		if _PrimordialWave_RDY then
			return ids.Covenant_Ability.PrimordialWave;
		end
		
		if _FlameShockRDY and not _FlameShockDEBUFF then
			return ids.Enh_Ability.FlameShock;
		end

		if fs and ConRO_FullButton:IsVisible() then
			return ids.Enh_Ability.FeralSpirit;
		end	

		if _LavaLashRDY and inMelee and (tChosen[ids.Enh_Talent.LashingFlames] and not _LashingFlamesDEBUFF) then
			return ids.Enh_Ability.LavaLash;
		end
		
		if ascen and not ss and ConRO_FullButton:IsVisible() then
			return ids.Enh_Talent.Ascendance;
		end
		
		if ss and asBuff then
			return ids.Enh_Talent.Windstrike;
		end
		
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end
		
		if _FrostShockRDY and _HailstormBUFF then
			return ids.Enh_Ability.FrostShock;
		end
		
		if espike and espikeRANGE then
			return ids.Enh_Talent.EarthenSpike;
		end

		if _FaeTransfusion_RDY then
			return ids.Covenant_Ability.FaeTransfusion;
		end

		if _StormkeeperBUFF and _MaelstromWeaponCOUNT >= 5 then
			if (ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible() then
				if _ChainLightningRDY then
					return ids.Enh_Ability.ChainLightning;
				end
			else
				if _LightningBoltRDY then
					return ids.Enh_Ability.LightningBolt;
				end
			end
		end
			
		if _ElementalBlastRDY and _MaelstromWeaponCOUNT >= 5 then
			return ids.Enh_Talent.ElementalBlast;
		end

		if _ChainHarvest_RDY and _MaelstromWeaponCOUNT >= 5 and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.ChainHarvest;
		end
		
		if _StormkeeperRDY and _MaelstromWeaponCOUNT >= 5 then
			return ids.Enh_Talent.Stormkeeper;
		end

		if _MaelstromWeaponCOUNT >= 8 then
			if (ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible() then
				if _ChainLightningRDY then
					return ids.Enh_Ability.ChainLightning;
				end
			else
				if _LightningBoltRDY then
					return ids.Enh_Ability.LightningBolt;
				end
			end
		end

		if _LavaLashRDY and inMelee and _HotHandBUFF then
			return ids.Enh_Ability.LavaLash;
		end

		if ss and inMelee and not asBuff then
			return ids.Enh_Ability.Stormstrike;
		end
		
		if cl and inMelee then
			return ids.Enh_Ability.CrashLightning;
		end
		
		if _LavaLashRDY and inMelee then
			return ids.Enh_Ability.LavaLash;
		end			
		
		if _FlameShockRDY and _FlameShockDUR < 5 then
			return ids.Enh_Ability.FlameShock;
		end			

		if _FrostShockRDY then
			return ids.Enh_Ability.FrostShock;
		end
		
		if _IceStrikeRDY and inMelee then
			return ids.Enh_Talent.IceStrike;
		end

		if sunder and tar10RANGE then
			return ids.Enh_Talent.Sundering;
		end		

		if _FireNovaRDY and inMelee and _FlameShockDEBUFF then
			return ids.Enh_Talent.FireNova;
		end

		if _MaelstromWeaponCOUNT >= 5 then
			if (ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible() then
				if _ChainLightningRDY then
					return ids.Enh_Ability.ChainLightning;
				end
			else
				if _LightningBoltRDY then
					return ids.Enh_Ability.LightningBolt;
				end
			end
		end
	end
return nil;
end

function ConRO.Shaman.EnhancementDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local mana 												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manaPercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	
--Abilities	
	local astral 											= ConRO:AbilityReady(ids.Enh_Ability.AstralShift, timeShift);
	local hsurge											= ConRO:AbilityReady(ids.Enh_Ability.HealingSurge, timeShift);

		local _, _MaelstromWeaponCOUNT							= ConRO:Aura(ids.Enh_Buff.MaelstromWeapon, timeShift);

	local _FaeTransfusionEND_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.FaeTransfusionEND, timeShift);	
		local _FaeTransfusion_BUFF								= ConRO:Aura(ids.Covenant_Buff.FaeTransfusion, timeShift);
	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local ph = ConRO:PercentHealth('player');

--Rotations	
	if _FaeTransfusionEND_RDY and _FaeTransfusion_BUFF then
		return ids.Covenant_Ability.FaeTransfusionEND;
	end
	
	if hsurge and ph <= 80 and _MaelstromWeaponCOUNT >= 5 then
		return ids.Enh_Ability.HealingSurge;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end	
	
	if astral then
		return ids.Enh_Ability.AstralShift;
	end
return nil;
end

function ConRO.Shaman.Restoration(_, timeShift, currentSpell, gcd, tChosen)
--Abilities
	local purge 											= ConRO:AbilityReady(ids.Resto_Ability.Purge, timeShift);	
	local wshear 											= ConRO:AbilityReady(ids.Resto_Ability.WindShear, timeShift);
	local lbolt												= ConRO:AbilityReady(ids.Resto_Ability.LightningBolt, timeShift);
	local clight											= ConRO:AbilityReady(ids.Resto_Ability.ChainLightning, timeShift);
	local eelem, eeCD, eeMCD								= ConRO:AbilityReady(ids.Resto_Ability.EarthElemental, timeShift);
	local lburst											= ConRO:AbilityReady(ids.Resto_Ability.LavaBurst, timeShift);
		local lavaCharges										= ConRO:SpellCharges(ids.Resto_Ability.LavaBurst);
		local lsurgeBuff 										= ConRO:Aura(ids.Resto_Buff.LavaSurge, timeShift);
	local fshock											= ConRO:AbilityReady(ids.Resto_Ability.FlameShock, timeShift);
		local fsDebuff 											= ConRO:TargetAura(ids.Resto_Debuff.FlameShock, timeShift + 6);
	local hsTotem											= ConRO:AbilityReady(ids.Resto_Ability.HealingStreamTotem, timeShift);
		
	local eshield											= ConRO:AbilityReady(ids.Resto_Ability.EarthShield, timeShift);

	local _ChainHarvest_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.ChainHarvest, timeShift);
	local _FaeTransfusion_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.FaeTransfusion, timeShift);
	local _PrimordialWave_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.PrimordialWave, timeShift);
	local _VesperTotem_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.VesperTotem, timeShift);
	
--Conditions	
	local isEnemy 											= ConRO:TarHostile();

	if currentSpell == ids.Resto_Ability.LavaBurst then
		lavaCharges = lavaCharges - 1;
	end
		
--Indicators
	ConRO:AbilityInterrupt(ids.Resto_Ability.WindShear, wshear and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Resto_Ability.Purge, purge and ConRO:Purgable());

	ConRO:AbilityRaidBuffs(ids.Resto_Ability.EarthShield, eshield and not ConRO:OneBuff(ids.Resto_Buff.EarthShield));
	ConRO:AbilityRaidBuffs(ids.Resto_Ability.HealingStreamTotem, hsTotem);
	
	ConRO:AbilityBurst(ids.Resto_Ability.EarthElemental, eelem and isEnemy);

--Rotations
	if isEnemy then
		if _VesperTotem_RDY then
			return ids.Covenant_Ability.VesperTotem;
		end
		
		if fshock and not fsDebuff then
			return ids.Resto_Ability.FlameShock;
		end	
		
		if lburst and lavaCharges >= 1 then
			return ids.Resto_Ability.LavaBurst;
		end

		if _FaeTransfusion_RDY then
			return ids.Covenant_Ability.FaeTransfusion;
		end
		
		if lbolt then
			return ids.Resto_Ability.LightningBolt;
		end
	end
return nil;
end

function ConRO.Shaman.RestorationDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities	
	local astral 											= ConRO:AbilityReady(ids.Resto_Ability.AstralShift, timeShift);

	local _FaeTransfusionEND_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.FaeTransfusionEND, timeShift);	
		local _FaeTransfusion_BUFF								= ConRO:Aura(ids.Covenant_Buff.FaeTransfusion, timeShift);
	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Rotations	
	if _FaeTransfusionEND_RDY and _FaeTransfusion_BUFF then
		return ids.Covenant_Ability.FaeTransfusionEND;
	end
	
	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end

	if astral then
		return ids.Resto_Ability.AstralShift;
	end
return nil;
end